/*
   Distort v1.0, written by Francois FLEURET
   Contact francois.fleuret@inria.fr for info & bugs reports
   THIS SOURCE IS VERY DIRTY, I KNOW IT :p
*/

#include <iostream.h>
#include <fstream.h>

#include "pictures.h"

float abs(float x) { if(x>0) return x; else return -x; }

int main(int argc, char **argv)
{
  Picture org;
  int block_size, result_w, result_h, w, h;

  int c;
  float xa, ya, alpha_x, alpha_y, s;
  int x, y, xx, yy;

  if(argc != 5)
    {
      cerr<<"\nusage : "<<argv[0]<<" <block size> <gride file> <source pic> <result pic>\n\n";
      cerr<<" <block size> is an integer\n";
      cerr<<" <gride file> is the name of a gride file\n";
      cerr<<" <source pic> is a pictures name, wich have to be in pgm or ppm format\n";
      cerr<<" <result pic> is the result picture name, wich will be in pgm\n\n";
      exit(1);
    }

  block_size = atoi(argv[1]);

  cerr<<"Blocks : "<<block_size<<"x"<<block_size<<" gride file : "<<argv[2]
    <<" source picture "<<argv[3]<<" result picture : "<<argv[4]<<"\n";

  cerr<<"Loading "<<argv[3]<<" ... "; cout.flush();
  org.LoadPpm(argv[3]);
  cerr<<"done\n"; cout.flush();

  cerr<<"Loading gride ... "; cout.flush();

  ifstream gride_file(argv[2]);

  if(!gride_file.fail()) gride_file>>w>>h;

  float x_v[w*h], y_v[w*h];

  if(!gride_file.fail())
    {
      for(y=0; y<h; y++)
	for(x=0; x<w; x++) gride_file>>x_v[x + y*w]>>y_v[x + y*w];
    };

  cerr<<"done\n"; cout.flush();

  cerr<<"Gride "<<w<<"x"<<h<<" with blocks size "<<block_size<<"\n";

  result_w = (w-1)*block_size;
  result_h = (h-1)*block_size;

  Picture result(result_w, result_h);

  float g, g_nw, g_ne, g_se, g_sw;
  int xa_e, ya_e;

  cerr<<"Correcting picture ... "; cout.flush();

  for(x = 0; x<w-1; x++)
    for(y=0; y<h-1; y++)
      {
	for(xx = 0; xx<block_size; xx++)
	  for(yy = 0; yy<block_size; yy++)
	    {
	      alpha_x = 1-float(xx)/block_size;
	      alpha_y = 1-float(yy)/block_size;

	      xa =
		alpha_x * alpha_y * x_v[x + y*w] +
		  (1-alpha_x) * alpha_y * x_v[x+1 + y*w] + 
		    alpha_x * (1 - alpha_y) * x_v[x + (y+1)*w] +
		      (1-alpha_x) * (1- alpha_y) * x_v[x+1 + (y+1)*w];
	      
	      ya =
		alpha_x * alpha_y * y_v[x + y*w] +
		  (1-alpha_x) * alpha_y * y_v[x+1 + y*w] + 
		    alpha_x * (1 - alpha_y) * y_v[x + (y+1)*w] +
		      (1-alpha_x) * (1- alpha_y) * y_v[x+1 + (y+1)*w];

	      xa_e = int(xa); alpha_x = 1-(xa-float(xa_e));
	      ya_e = int(ya); alpha_y = 1-(ya-float(ya_e));

	      g_nw = org.GetComponent(xa_e, ya_e, PIC_RED);
	      g_ne = org.GetComponent(xa_e+1, ya_e, PIC_RED);
	      g_se = org.GetComponent(xa_e+1, ya_e+1, PIC_RED);
	      g_sw = org.GetComponent(xa_e, ya_e+1, PIC_RED);

	      g = g_nw*alpha_x*alpha_y + g_ne*(1-alpha_x)*alpha_y +
		g_se*(1-alpha_x)*(1-alpha_y) + g_sw*alpha_x*(1-alpha_y);

	      for(c=0; c<PIC_DEPTH; c++)
		result.SetComponent(x*block_size + xx, y*block_size+yy, c, g);
	    }
      }
  cerr<<"done\n"; cout.flush();

  cerr<<"Saving in "<<argv[4]<<" ... "; cout.flush();
  result.SavePpm(argv[4]);
  cerr<<"done\n"; cout.flush();
}
