/*-----------------------------------------------------------------------------
  Code written by Francois Fleuret, using GCC & Emacs
  Jun-Nov 1995
  Contact <francois.fleuret@inria.fr>
-----------------------------------------------------------------------------*/

// A class to manipulate pictures. June 1995.
// gcc/SunOS
// francois.fleuret@inria.fr
// Thanxxxxx to Emacs & gcc

/*---------------------------------------------------------------------------*/

#ifndef PICTURES_H
#define PICTURES_H

#define BUFFER_SIZE 256

/*---------------------------------------------------------------------------*/

#include <iostream.h>
#include <math.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <fcntl.h>

#include "array.h"

extern "C" int read(int, char *, int);
extern "C" int write(int, char *, int);
//extern "C" int open(char *, int);
extern "C" int close(int);

/*
extern "C" image *image_(char *, char *, char *, nf_fmt *);
extern "C" c_lecflt(image *, int, unsigned char *);
extern "C" c_ecrflt(image *, int, unsigned char *);
extern "C" fermnf_(image **);
*/

/*---------------------------------------------------------------------------*/

// 3 floats par pixel
#define PIC_DEPTH 3

#define PIC_RED 0
#define PIC_GREEN 1
#define PIC_BLUE 2

#define LARGEUR_TRUC 9
#define HAUTEUR_TRUC (MAX_TAGIFICATION/LARGEUR_TRUC)

/*---------------------------------------------------------------------------*/

class Picture
{
private:
  Array<float> Body;
  
public:
  int SizeX, SizeY;
  
public:

  Picture();
  Picture(Picture &v);
  Picture(int SX, int SY);
  ~Picture();

  float GetComponent(int x, int y, int n);
  void SetComponent(int x, int y, int n, float v);

  void Clear();
  void Fill(float v);

  void Blur(int s);

  void Free();
  void Reformat(int x, int y);

  void Reverse();
  void ToBN();
  void AddBorders(int w, float r, float g, float b);

  void LoadPpm(char *file_name);
  void SavePpm(char *file_name);

  void ReSize(int nx, int ny);
  void Cut(int x, int y, int w, int h, Picture &src);
  void Copy(int xd, int yd, int xs, int ys, int w, int h, Picture &src);
  int operator == (Picture &src);
  void operator = (Picture &src);

  float Picture::DistanceL2(Picture *p);
};

/*---------------------------------------------------------------------------*/

#endif
